
# ~/.zshenv

# Folding used. get folding.el for your emacs here:
# http://www.csd.uu.se/~andersl/emacs.shtml

#echo "~/.zshenv"

# TODO:
# 
# When version 5.0.0 is installed, enable or disable these:
#

# COMBINING_CHARS, DEBUG_BEFORE_CMD, HASH_EXECUTABLES_ONLY, HIST_FCNTL_LOCK,
# HIST_LEX_WORDS, HIST_SAVE_BY_COPY, NO_MULTI_FUNCDEF, PATH_SCRIPT, PROMPT_SP,
# SOURCE_TRACE. 


emulate zsh

# {{{ Loading help

#emulate ksh

# .kshrc may have something too ksh-specific
#. "${HOME}/.kshrc"
#HOME_KSHRC="1"
#export HOME_KSHRC

#if [ -n "$HOME_KSHRC" ]
#then
#  if [ "$HOME_KSHRC" -gt 0 ]
#  then
#     echo PAH ~/.kshrc
#     :
#  fi
#else
#  echo SUCK ~/.kshrc
#  HOME_KSHRC="1"
#  export HOME_KSHRC
#  . "$HOME/.kshrc"
#fi

#if [ "$HOME_SHINIT" ]
#then
# if [ "$HOME_SHINIT" -gt 0 ]
# then
#   true
##   echo PAH $HOME/.shinit.sh
# fi
#else
##  echo SUCK $HOME/.shinit.sh
#  . $HOME/.shinit.sh
#fi

. ${HOME}/.shinit.sh
#export HOME_SHINIT="1"

# }}}


# automatically remove duplicates from these arrays
typeset -U path cdpath fpath manpath

# {{{ Setopt

setopt ALWAYS_TO_END
setopt APPEND_HISTORY
setopt AUTO_CD
setopt AUTO_CONTINUE
setopt AUTO_LIST
setopt AUTO_MENU
setopt AUTO_PARAM_SLASH
setopt BAD_PATTERN
setopt BANG_HIST
setopt BEEP
setopt BSD_ECHO
setopt CDABLE_VARS
setopt CHASELINKS
setopt CHECK_JOBS
setopt COMPLETE_IN_WORD
setopt CORRECT
setopt CORRECT_ALL
setopt EXTENDED_HISTORY
setopt FLOW_CONTROL
setopt GLOB

setopt HASH_CMDS
setopt HASH_DIRS
setopt HASH_LIST_ALL

setopt HIST_BEEP
setopt HIST_EXPIRE_DUPS_FIRST
setopt HIST_FCNTL_LOCK
setopt HIST_FIND_NO_DUPS
setopt HIST_IGNORE_ALL_DUPS
setopt HIST_IGNORE_DUPS
setopt HIST_NO_STORE
setopt HIST_REDUCE_BLANKS
setopt HIST_SAVE_BY_COPY
setopt HIST_SAVE_NO_DUPS
setopt HIST_VERIFY

setopt INTERACTIVE_COMMENTS
setopt LIST_BEEP
setopt LIST_TYPES
setopt LONG_LIST_JOBS
setopt NUMERIC_GLOB_SORT
setopt PATH_DIRS

setopt PRINT_EXIT_VALUE
setopt PROMPT_CR
setopt PUSHD_IGNORE_DUPS
setopt RC_EXPAND_PARAM
setopt RCS

# THIS IS GOOD FOR LOOPS:
# for f in `foo`
# do
#  bar $f
# done
# Otherwise it will do:
# bar <every word from output of foo>
setopt SH_WORD_SPLIT

setopt SH_OPTION_LETTERS

setopt SHORT_LOOPS

### Not in alphabetical order:

## setopt *GLOB*
setopt CSH_NULL_GLOB
setopt EXTENDED_GLOB

## For UTF-8-support
setopt COMBINING_CHARS
setopt MULTIBYTE
setopt PRINT_EIGHT_BIT

## POSIX me harder
setopt POSIX_ALIASES 2> /dev/null
setopt POSIX_BUILTINS 2> /dev/null
setopt POSIX_CD 2> /dev/null
setopt POSIX_IDENTIFIERS 2> /dev/null
setopt POSIX_JOBS 2> /dev/null
# Is this really good?
setopt POSIX_STRINGS 2> /dev/null
setopt POSIX_TRAPS 2> /dev/null


# }}}
# {{{ Unsetopt

unsetopt AUTOPUSHD
unsetopt AUTOREMOVESLASH
unsetopt BG_NICE
unsetopt CHECK_JOBS
unsetopt CLOBBER
unsetopt CLOBBER

unsetopt CSH_JUNKIE_HISTORY
unsetopt CSH_JUNKIE_LOOPS
unsetopt CSH_JUNKIE_QUOTES

unsetopt ERR_EXIT
unsetopt GLOB_COMPLETE
unsetopt HIST_ALLOW_CLOBBER
unsetopt HIST_IGNORE_SPACE
unsetopt HUP
unsetopt IGNORE_EOF
unsetopt INC_APPEND_HISTORY

unsetopt KSH_ARRAYS
unsetopt KSH_AUTOLOAD
unsetopt KSH_OPTION_PRINT
unsetopt KSH_TYPESET
unsetopt KSH_ZERO_SUBSCRIPT

unsetopt MAIL_WARNING


# THIS IS GOOD. OTHERWISE YOU'LL SHOOT YOURSELF INTO THE FOOT:
# for f in * ; do ; zip -r "${f}.zip" "${f}" ; done
# It will do this for each file:
# zip -r file/.zip file/
#            ^
unsetopt MARK_DIRS


unsetopt MENU_COMPLETE
unsetopt NOMATCH
unsetopt NOTIFY

# This causes weird behaviour very easily, if this is on:
# ls /home/juhtolv/.profile.ubuntu.*
# becomes:
# ls /home/juhtolv
# and then it list everything from that directory.
unsetopt NULL_GLOB


unsetopt PUSHD_SILENT
unsetopt PUSHD_TO_HOME
unsetopt RM_STAR_SILENT

unsetopt RESTRICTED
unsetopt SHARE_HISTORY

# }}}

